;
;		RESTRICTED RIGHTS LEGEND
;		------------------------
;	
;	    "Use, duplication, or disclosure by the
;	Government is subject to restrictions as set forth
;	in paragraph (b) (3) (B) of the Rights in Technical
;	Data and Computer Software clause in DAR
;	7-104.9(a).  Contractor/manufacturer is Zenith
;	Data Systems Corporation of Hilltop Road, St.
;	Joseph, Michigan 49085.
;
;
; 6845 CRT-CONTROLLER EQUATES
;

;	PORT DISPLACEMENTS

CRTREG	EQU	0		; CRT-C REGISTER SELECT
CRTDAT	EQU	1		; CRT-C DATA


;	CRT-C INTERNAL REGISTERS
;	NOTE: A "*" INDICATES THE VALUE WRITTEN/READ IS ONE
;             LESS THAN ACTUAL VALUE
 

CRTHT	EQU	0		; * HORIZONTAL TOTAL
CRTHD	EQU	1		; HORIZONTAL DISPLAYED
CRTHSP	EQU	2		; * HORIZONTAL SYNC POSITION
CRTSW	EQU	3		; SYNC WIDTH
  CRTSW_WH  EQU  00001111B	  ; HORIZONTAL WIDTH
  CRTSW_WV  EQU  11110000B	  ; VERTICAL WIDTH			
CRTVT	EQU	4		; * VERTICAL TOTAL
CRTVTA	EQU	5		; VERTICAL TOTAL ADJUST
CRTVD	EQU	6		; VERTICAL DISPLAYED
CRTVSP	EQU	7		; * VERTICAL SYNC POSITION
CRTIS	EQU	8		; INTERLACE AND SKEW
  CRTIS_IS  EQU  00000001B	  ; INTERLACE SYNC
  CRTIS_ISV EQU  00000011B	  ; INTERLACE AND SYNC
  CRTIS_DS1 EQU  00010000B	  ; DISPTMG ONE-CHR SKEW
  CRTIS_DS2 EQU  00100000B	  ; DISPTMG TWO-CHR SKEW
  CRTIS_DNO EQU  00110000B	  ; NON-OUTPUT
  CRTIS_CS1 EQU  01000000B	  ; CURSOR ONE-CHR SKEW
  CRTIS_CS2 EQU  10000000B	  ; CURSOR TWO-CHR SKEW
  CRTIS_CNO EQU  11000000B	  ; NON-OUTPUT
CRTMRA	EQU	9		; MAXIMUM RASTER ADDRESS
CRTCSR	EQU	10		; CURSOR START RASTER
  CRTCSR_SRA EQU 00011111B	  ; START RASTER ADDRESS
  CRTCSR_ND EQU  00100000B	  ; NOT DISPLAYED
  CRTCSR_BS EQU  00100000B	  ; BLINK SLOW(WITH CRTCSR_CB)
  CRTCSR_CB EQU  01000000B	  ; BLINK ENABLE	
CRTCER	EQU	11		; CURSOR END RASTER
CRTSAH	EQU	12		; START ADDRESS (MSB)
CRTSAL	EQU	13		; START ADDRESS (LSB)
CRTCH	EQU	14		; CURSOR (MSB)
CRTCL	EQU	15		; CURSOR (LSB)
CRTLPH	EQU	16		; LIGHT PEN ADDRESS (MSB)
CRTLPL	EQU	17		; LIGHT PEN ADDRESS (LSB)
