;
;		RESTRICTED RIGHTS LEGEND
;		------------------------
;	
;	    "Use, duplication, or disclosure by the
;	Government is subject to restrictions as set forth
;	in paragraph (b) (3) (B) of the Rights in Technical
;	Data and Computer Software clause in DAR
;	7-104.9(a).  Contractor/manufacturer is Zenith
;	Data Systems Corporation of Hilltop Road, St.
;	Joseph, Michigan 49085.
;
;
; Definitions for 6821 Peripheral interface adapter(PIA)
;

;	Register displacements

PIADATA	=	0		;PERIPHERAL DATA REGISTER A
PIADDRA	=	0		;DATA DIRECTION REGISTER A
PIACTLA	=	1		;CONTROL REGISTER A
PIADATB	=	2		;PERIPHERAL DATA REGISTER B
PIADDRB	=	2		;DATA DIRECTION REGISTER B
PIACTLB	=	3		;CONTROL REGISTER B

;	CONTROL WORD FORMAT

PIAC1	=	00000011B	;CONTROL OF CA1(CB1) INTERRUPT LINE
PIAC10	=	00H		; ACTIVE TRANSITION 1->0
				;  IRQ PIN IS DISABLED
PIAC11	=	01H		; ACTIVE TRANSITION 1->0
				;  IRQ PIN IS ENABLED
PIAC12	=	02H		; ACTIVE TRANSITION 0->1
				;  IRQ PIN IS DISABLED
PIAC13	=	03H		; ACTIVE TRANSITION 0->1
				;  IRQ PIN IS ENABLED

PIADDAC	=	00000100B	;DATA DIRECTION ACCESS CONTROL BIT
				; 0=DATA DIRECTION REG, 1=PERIPHERAL DATA REG

PIAC2	=	00111000B	;CONTROL OF CA2(CB2)
				; INPUT MODES
PIAC20	=	00H		;  ACTIVE TRANSITION 1->0
				;   IRQ PIN IS DISABLED
PIAC21	=	08H		;  ACTIVE TRANSITION 1->0
				;   IRQ PIN IS ENABLED
PIAC22	=	10H		;  ACTIVE TRANSITION 0->1
				;   IRQ PIN IS DISABLED
PIAC23	=	18H		;  ACTIVE TRANSITION 0->1
				;   IRQ PIN IS ENABLED
				; OUTPUT MODES
PIAC24	=	20H		;  0 ON R(W) OPERATION, 1 ON ACTIVE CA1(CB1)
PIAC25	=	28H		;  0 ON R(W) OPERATION, 1 ON E AFTER DESELECT
PIAC26	=	30H		;  RESET
PIAC27	=	38H		;  SET

PIAIRQ2	=	01000000B	;IRQ FOR CA2(CB2)
PIAIRQ1	=	10000000B	;IRQ FOR CA1(CB1)

