;
;		RESTRICTED RIGHTS LEGEND
;		------------------------
;	
;	    "Use, duplication, or disclosure by the
;	Government is subject to restrictions as set forth
;	in paragraph (b) (3) (B) of the Rights in Technical
;	Data and Computer Software clause in DAR
;	7-104.9(a).  Contractor/manufacturer is Zenith
;	Data Systems Corporation of Hilltop Road, St.
;	Joseph, Michigan 49085.
;
;
; 6845 CRT-CONTROLLER =ATES
;

;	PORT DISPLACEMENTS

CRTREG	=	0		; CRT-C REGISTER SELECT
CRTDAT	=	1		; CRT-C DATA


;	CRT-C INTERNAL REGISTERS
;	NOTE: A "*" INDICATES THE VALUE WRITTEN/READ IS ONE
;             LESS THAN ACTUAL VALUE
 

CRTHT	=	0		; * HORIZONTAL TOTAL
CRTHD	=	1		; HORIZONTAL DISPLAYED
CRTHSP	=	2		; * HORIZONTAL SYNC POSITION
CRTSW	=	3		; SYNC WIDTH
  CRTSW_WH  =  00001111B	  ; HORIZONTAL WIDTH
  CRTSW_WV  =  11110000B	  ; VERTICAL WIDTH			
CRTVT	=	4		; * VERTICAL TOTAL
CRTVTA	=	5		; VERTICAL TOTAL ADJUST
CRTVD	=	6		; VERTICAL DISPLAYED
CRTVSP	=	7		; * VERTICAL SYNC POSITION
CRTIS	=	8		; INTERLACE AND SKEW
  CRTIS_IS  =  00000001B	  ; INTERLACE SYNC
  CRTIS_ISV =  00000011B	  ; INTERLACE AND SYNC
  CRTIS_DS1 =  00010000B	  ; DISPTMG ONE-CHR SKEW
  CRTIS_DS2 =  00100000B	  ; DISPTMG TWO-CHR SKEW
  CRTIS_DNO =  00110000B	  ; NON-OUTPUT
  CRTIS_CS1 =  01000000B	  ; CURSOR ONE-CHR SKEW
  CRTIS_CS2 =  10000000B	  ; CURSOR TWO-CHR SKEW
  CRTIS_CNO =  11000000B	  ; NON-OUTPUT
CRTMRA	=	9		; MAXIMUM RASTER ADDRESS
CRTCSR	=	10		; CURSOR START RASTER
  CRTCSR_SRA = 00011111B	  ; START RASTER ADDRESS
  CRTCSR_ND =  00100000B	  ; NOT DISPLAYED
  CRTCSR_BS =  00100000B	  ; BLINK SLOW(WITH CRTCSR_CB)
  CRTCSR_CB =  01000000B	  ; BLINK ENABLE	
CRTCER	=	11		; CURSOR END RASTER
CRTSAH	=	12		; START ADDRESS (MSB)
CRTSAL	=	13		; START ADDRESS (LSB)
CRTCH	=	14		; CURSOR (MSB)
CRTCL	=	15		; CURSOR (LSB)
CRTLPH	=	16		; LIGHT PEN ADDRESS (MSB)
CRTLPL	=	17		; LIGHT PEN ADDRESS (LSB)
