;
;		RESTRICTED RIGHTS LEGEND
;		------------------------
;	
;	    "Use, duplication, or disclosure by the
;	Government is subject to restrictions as set forth
;	in paragraph (b) (3) (B) of the Rights in Technical
;	Data and Computer Software clause in DAR
;	7-104.9(a).  Contractor/manufacturer is Zenith
;	Data Systems Corporation of Hilltop Road, St.
;	Joseph, Michigan 49085.
;
;
; Definitions for 8253 programmable interval timer
;

;  PORT DISPLACEMENTS

PITC0	=	000H		;COUNTER 0
PITC1	=	001H		;COUNTER 1
PITC2	=	002H		;COUNTER 2
PITCW	=	003H		;CONTROL WORD

;  CONTROL WORD

PITSC	=	11000000B	;SELECT COUNTER
PITSC0	=	000H		; 0
PITSC1	=	040H		; 1
PITSC2	=	080H		; 2

PITRL	=	00110000B	;READ/LOAD
PITRLCL	=	000H		; COUNTER LATCHING OPERATION
PITRLMB	=	010H		; MSB
PITRLLB	=	020H		; LSB
PITRLW	=	030H		; WORD

PITM	=	00001110B	;MODE
PITMITC	=	000H		; 0 - INTERRUPT ON TERMINAL COUNT
PITMP1S	=	002H		; 1 - PROGRAMMABLE ONE SHOT
PITMRG	=	004H		; 2 - RATE GENERATOR
PITMSW	=	006H		; 3 - SQUARE WAVE RATE GENERATOR
PITMSTS	=	008H		; 4 - SOFTWARE TRIGGERED STROBE
PITMHTS	=	00AH		; 5 - HARDWARE TRIGGERED STROBE

PITBCD	=	00000001B	;0 = 16 BIT BINARY COUNTER
				;1 = 4 DIGIT BCD COUNTER
